SystemOrganization addCategory: #TusLibros!

Object subclass: #Cart
	instanceVariableNames: 'items catalogue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 5/29/2013 21:04'!
createWithCatalogue: aCatalogue 
	^ self new initializeEmptyWithCatalogue: aCatalogue ! !

!Cart class methodsFor: 'error handling' stamp: 'EtchegoyenLajePulver 5/29/2013 21:13'!
nonCataloguedBookDescription
	^ 'Catalogue doesnt contain item'! !

!Cart methodsFor: 'adding' stamp: 'EtchegoyenLajePulver 5/29/2013 21:06'!
add: anItem
	self add: anItem withOccurrences: 1.! !

!Cart methodsFor: 'adding' stamp: 'EtchegoyenLajePulver 6/1/2013 17:36'!
add: anItem  withOccurrences: anInteger
	catalogue at: anItem ifPresent: [ :aValue |  ] ifAbsent:  [Error signal: 'Catalogue doesnt contain item'].
	items add: anItem withOccurrences: anInteger! !

!Cart methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/29/2013 20:25'!
includes: anItem
	^ items includes: anItem! !

!Cart methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 5/29/2013 21:04'!
initializeEmptyWithCatalogue: aCatalogue
	items:= Bag new.
	catalogue:= aCatalogue ! !

!Cart methodsFor: 'enumerating' stamp: 'EtchegoyenLajePulver 6/1/2013 18:02'!
inject: aValue into: aBinaryBlock
	^ items inject: aValue into: aBinaryBlock ! !

!Cart methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/29/2013 20:21'!
isEmpty
	^ items isEmpty ! !

!Cart methodsFor: 'testing' stamp: 'EtchegoyenLajePulver 5/29/2013 20:40'!
occurrencesOf: anItem
	^ items occurrencesOf: anItem ! !

!Cart methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/29/2013 20:29'!
size
	^ items size! !

Object subclass: #CartTimedWrapper
	instanceVariableNames: 'timeStamp cart timeOutSeconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!CartTimedWrapper class methodsFor: 'testing' stamp: 'EtchegoyenLajePulver 6/3/2013 16:17'!
timeOutDescription
	^ 'Cart timed out'.! !

!CartTimedWrapper class methodsFor: 'instance creation' stamp: 'EtchegoyenLajePulver 6/3/2013 16:58'!
withCart: aCart TimeStamp: aTimeStamp andTimeOutInSeconds: aNumber
	^ self new initializeWithCart: aCart TimeStamp: aTimeStamp andTimeOutInSeconds: aNumber! !

!CartTimedWrapper methodsFor: 'message redirecting' stamp: 'EtchegoyenLajePulver 6/3/2013 17:45'!
doesNotUnderstand: aMessage 
	((TimeStamp now plusSeconds: ( 0-timeOutSeconds)) > timeStamp) ifTrue: [ Error signal: self class timeOutDescription ].
	timeStamp := TimeStamp now.
	aMessage sendTo: cart! !

!CartTimedWrapper methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/3/2013 17:45'!
initializeWithCart: aCart TimeStamp: aTimeStamp andTimeOutInSeconds: aNumber
	timeStamp := aTimeStamp.
	timeOutSeconds := aNumber.
	cart:= aCart.! !

!CartTimedWrapper methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 6/3/2013 17:45'!
minutesToLive
	^ ((timeStamp asDateAndTime plusSeconds: timeOutSeconds) - DateAndTime now) minutes +1! !

!CartTimedWrapper methodsFor: 'message redirecting' stamp: 'EtchegoyenLajePulver 6/3/2013 17:24'!
size 
	^ cart size! !

Object subclass: #Cashier
	instanceVariableNames: 'priceCatalogue salesBook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'error handling' stamp: 'EtchegoyenLajePulver 5/29/2013 21:28'!
cartEmptyErrorDescription
	^ 'Cannot check out empy cart'! !

!Cashier class methodsFor: 'error handling' stamp: 'EtchegoyenLajePulver 6/1/2013 19:39'!
creditCardNameMismatchDescription 
	^ 'credit card and client names mismatch'! !

!Cashier class methodsFor: 'error handling' stamp: 'EtchegoyenLajePulver 6/1/2013 17:14'!
outOfDateCreditCardErrorDescription
	^ 'Invalid payment attempt with expired credit card'! !

!Cashier class methodsFor: 'instance creation' stamp: 'EtchegoyenLajePulver 6/1/2013 18:28'!
withPriceCatalogue: aDictionary 
	^ self new initializeWithCatalogue: aDictionary andSalesBook: (Set new).! !

!Cashier class methodsFor: 'instance creation' stamp: 'EtchegoyenLajePulver 6/1/2013 18:25'!
withPriceCatalogue: aDictionary andSalesBook: aSalesBook
	^ self new initializeWithCatalogue: aDictionary andSalesBook: aSalesBook.! !

!Cashier methodsFor: 'apply primitives' stamp: 'EtchegoyenLajePulver 6/1/2013 19:45'!
checkout: aCart withCreditCard: aCreditCard andClient: aClient
	|aSale|
	aCart isEmpty ifTrue: [ ^ Error signal: self class cartEmptyErrorDescription ].
	
	aCreditCard isDue ifTrue: [ ^ Error signal: self class outOfDateCreditCardErrorDescription ].
	
	(aCreditCard name ~= aClient) ifTrue: [ ^ Error signal: self class creditCardNameMismatchDescription ].
	
	aSale := Sale withCart: aCart withCreditCard: aCreditCard withPriceCatalog: priceCatalogue andClient: aClient.
	salesBook add: aSale.
	^ aSale.! !

!Cashier methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/1/2013 18:26'!
initializeWithCatalogue: aDictionary andSalesBook: aSalesBook
	priceCatalogue:= aDictionary.
	salesBook:= aSalesBook.! !

Object subclass: #CreditCard
	instanceVariableNames: 'expirationDate ownerName bin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!CreditCard class methodsFor: 'instance creation' stamp: 'EtchegoyenLajePulver 6/1/2013 17:02'!
createWithExpirationDate: aDate ownerName: aString andBin:  anotherString
	^self new initializeWithExpirationDate: aDate ownerName: aString andBin: anotherString
	! !

!CreditCard methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/1/2013 17:02'!
initializeWithExpirationDate: aDate ownerName: aString andBin: anotherString
	expirationDate := aDate.
	ownerName:= aString.
	bin:= anotherString.! !

!CreditCard methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 6/1/2013 17:20'!
isDue
	^ expirationDate < Date today ! !

!CreditCard methodsFor: 'accessing' stamp: 'EtchegoyenLajePulver 6/1/2013 19:41'!
name 
	^ ownerName! !

Object subclass: #Sale
	instanceVariableNames: 'cart creditCard priceCatalog date client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Sale class methodsFor: 'instance creation' stamp: 'EtchegoyenLajePulver 6/1/2013 19:23'!
withCart: aCart withCreditCard: aCreditCard withPriceCatalog: aPriceCatalog andClient: aClient
	^self new initializeWithCart: aCart withCreditCard: aCreditCard withPriceCatalog: aPriceCatalog andClient: aClient! !

!Sale methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 6/1/2013 17:56'!
amount
	^ cart inject: 0 into: [ :partialSum :item | partialSum + (priceCatalog at: item) ]! !

!Sale methodsFor: 'accessing' stamp: 'EtchegoyenLajePulver 6/1/2013 19:24'!
client
	^ client! !

!Sale methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/1/2013 19:24'!
initializeWithCart: aCart withCreditCard: aCreditCard withPriceCatalog: aPriceCatalog andClient: aClient
	cart:= aCart.
	creditCard := aCreditCard copy.
	priceCatalog:= aPriceCatalog copy.
	client:= aClient copy.
	date := DateAndTime now.! !

Object subclass: #SalesBook
	instanceVariableNames: 'sales'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!SalesBook methodsFor: 'adding' stamp: 'EtchegoyenLajePulver 6/1/2013 19:17'!
add: aSale
	sales add: aSale! !

!SalesBook methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 6/1/2013 19:16'!
includes: aSale
	^ sales includes: aSale! !

!SalesBook methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/1/2013 19:15'!
initialize 
	sales:= Set new.! !

!SalesBook methodsFor: 'filtering' stamp: 'EtchegoyenLajePulver 6/1/2013 19:19'!
purchasesFrom: aClient
	^ sales select: [ :aSale | aSale client = aClient ]! !

!SalesBook methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 6/1/2013 19:16'!
size
	^ sales size! !

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/3/2013 17:40'!
a20MinutesRemainingCart
	| aTimeStamp |
	aTimeStamp := TimeStamp now plusSeconds: (-600).
	^ CartTimedWrapper withCart: (self anEmptyCart) TimeStamp: aTimeStamp andTimeOutInSeconds: 1800.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/29/2013 21:22'!
aCashier
	^ Cashier withPriceCatalogue: self aPriceCatalogue! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 18:16'!
aCashierWithSalesBook: aSalesBook
	^ Cashier withPriceCatalogue: self aPriceCatalogue andSalesBook: aSalesBook! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/29/2013 21:09'!
aNonCataloguedTestBook 
	^ '3'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/3/2013 17:17'!
aNonTimedOutCart
	| aTimeStamp |
	aTimeStamp := TimeStamp now.
	^ CartTimedWrapper withCart: (self anEmptyCart) TimeStamp: aTimeStamp andTimeOutInSeconds: 1800.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/29/2013 21:25'!
aPriceCatalogue 
	^ Dictionary newFromPairs: {self aTestBook. 10. self anotherTestBook. 30}! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/29/2013 21:09'!
aTestBook 
	^ '1'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 19:12'!
aTestClient
	^ 'Will Smith'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/3/2013 17:10'!
aTimedOutCart
	| aTimeStamp |
	aTimeStamp := TimeStamp now plusSeconds: (-1801).
	^ CartTimedWrapper withCart: (self anEmptyCart) TimeStamp: aTimeStamp andTimeOutInSeconds: 1800.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 17:07'!
aValidCreditCard
	^ CreditCard createWithExpirationDate: (Date today addDays: 2) ownerName: 'Will Smith' andBin: '1234'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 17:32'!
anEmptyCart
	^ Cart createWithCatalogue: self aPriceCatalogue ! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 19:14'!
anEmptySalesBook
	^ SalesBook new! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 17:04'!
anOutOfDateCreditCard
	^ CreditCard createWithExpirationDate: (Date today addDays: -2) ownerName: 'John' andBin: '123'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/29/2013 21:09'!
anotherTestBook 
	^ '2'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 19:13'!
anotherTestClient
	^ 'Tommy Lee Jones'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 19:11'!
anotherValidCreditCard
	^ CreditCard createWithExpirationDate: (Date today addDays: 2) ownerName: 'Tommy Lee Jones' andBin: '12345'! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test01NewCartShouldBeEmpty
	self assert: self anEmptyCart isEmpty! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test02BookShouldBePresentAfterBeingAdded
	|aCart aBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	aCart add: aBook.
	
	self assert: (aCart includes: aBook)! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test03CartShouldNotBeEmptyAfterAddingBook
	|aCart aBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	aCart add: aBook.
	
	self deny: (aCart isEmpty)! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test04EmptyCartHasSize0
	|aCart|
	aCart:= self anEmptyCart.
	self assert: (aCart size = 0)! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test05EachAddedBookIncreasesCartSize
	|aCart aBook anotherBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	anotherBook := self anotherTestBook.

	self assert: (aCart size = 0).
	aCart add: aBook.
	self assert: (aCart size = 1).
	aCart add: anotherBook.
	self assert: (aCart size = 2).! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test06OnlyAddedBooksShouldBePresent
	|aCart aBook anotherBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	anotherBook:= self anotherTestBook.
	aCart add: aBook.
	
	self assert: (aCart includes: aBook).
	self deny: (aCart includes: anotherBook).
	self assert: (aCart size = 1)! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test07BookNotAddedToCartHasNoOcurrencesInCart
	|aCart aBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	
	self assert: ((aCart occurrencesOf: aBook) = 0)! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test08EachBookAddedToCartIncreasesOccurrencesInCart
	|aCart aBook anotherBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	anotherBook:= self anotherTestBook.
	
	aCart add: aBook.
	self assert: ((aCart occurrencesOf: aBook) = 1).
	aCart add: aBook.
	self assert: ((aCart occurrencesOf: aBook) = 2).
	self assert: ((aCart occurrencesOf: anotherBook) = 0)! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test09AddingBooksWithQuantityIncreasesOccurrencesSameQuantity
	|aCart aBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
		
	aCart add: aBook.
	aCart add: aBook withOccurrences: 9.
	self assert: ((aCart occurrencesOf: aBook) = 10).! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 21:11'!
test10NonCataloguedBooksShouldntBeAbleToBeAdded
	|aCart aBook|
	aCart:= self anEmptyCart.
	aBook:= self aNonCataloguedTestBook.
		
	self should: [aCart add: aBook] raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cart nonCataloguedBookDescription ].
! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 6/1/2013 19:27'!
test11ShouldntBeAbleToCheckOutEmptyCart
	| aCart aCashier aCreditCard |
	aCart := self anEmptyCart.
	aCashier := self aCashier.
	aCreditCard:= self aValidCreditCard.
	self should: [aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier cartEmptyErrorDescription ]! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 6/1/2013 19:28'!
test12ShouldntBeAbleToCheckOutWithOutOfDateCreditCard
	| aCart aCashier aCreditCard |
	aCart := self anEmptyCart.
	aCashier := self aCashier.
	aCreditCard := self anOutOfDateCreditCard.
	
	aCart add: self aTestBook.
	
	self should: [aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient ]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier outOfDateCreditCardErrorDescription ]! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 6/1/2013 19:29'!
test13CashierShouldCalculateRightTotalAmount
	| aCart aCashier aCreditCard |
	aCart := self anEmptyCart.
	aCashier := self aCashier.
	aCreditCard:= self aValidCreditCard.
	aCart add: self aTestBook.
	aCart add: self anotherTestBook.
	
	self assert: ((aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient ) amount = 40).
	
	aCart add: self aTestBook.
	
	self assert: ((aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient) amount = 50)! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 6/1/2013 19:28'!
test14CashierShouldWriteSaleToSalesBook
	| aCart aCashier aCreditCard aSalesBook sale1 sale2|
	aCart := self anEmptyCart.
	aCreditCard:= self aValidCreditCard.
	aSalesBook:= self anEmptySalesBook.
	aCashier := self aCashierWithSalesBook: aSalesBook.
	
	aCart add: self aTestBook.
	aCart add: self anotherTestBook.
	
	self assert: (aSalesBook size = 0).
	sale1 := aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient.
	self assert: (aSalesBook size = 1).
	sale2:= aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient.
	self assert: (aSalesBook size = 2).
	self assert: (aSalesBook includes: sale1).
	self assert: (aSalesBook includes: sale2).! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 6/1/2013 19:28'!
test15CashierShouldntCreateSaleWhenPaymentErrorsOccurred
	| aCart aCashier aCreditCard aSalesBook|
	aCart := self anEmptyCart.
	aSalesBook:= self anEmptySalesBook.
	aCashier := self aCashierWithSalesBook: aSalesBook.
	aCreditCard:= self aValidCreditCard.
	self should: [aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier cartEmptyErrorDescription ].
	
	self assert: (aSalesBook size = 0).
	
	aCreditCard := self anOutOfDateCreditCard.
	aCart add: self aTestBook.
	self should: [aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier outOfDateCreditCardErrorDescription ].
	
	self assert: (aSalesBook size = 0).! !

!TusLibrosTest methodsFor: 'SalesBook' stamp: 'EtchegoyenLajePulver 6/1/2013 19:26'!
test16SalesBookShouldKnowAClientSales
	| aCart aCashier aSalesBook aCreditCard anotherCreditCard aClient anotherClient sale1 sale2 sale3|
	aCart := self anEmptyCart.
	aSalesBook:= self anEmptySalesBook.
	aCashier := self aCashierWithSalesBook: aSalesBook.
	aCreditCard:= self aValidCreditCard.
	anotherCreditCard:= self anotherValidCreditCard.
	aClient := self aTestClient.
	anotherClient := self anotherTestClient.
	
	self assert: ((aSalesBook purchasesFrom: aClient) size = 0).
	self assert: ((aSalesBook purchasesFrom: anotherClient) size = 0).
	
	aCart add: self aTestBook.
	sale1:= aCashier checkout: aCart withCreditCard: aCreditCard andClient: aClient.
	sale2:= aCashier checkout: aCart withCreditCard: aCreditCard andClient: aClient.	
	sale3:= aCashier checkout: aCart withCreditCard: anotherCreditCard andClient: anotherClient.
	
	self assert: ((aSalesBook purchasesFrom: aClient) size = 2).
	self assert: ((aSalesBook purchasesFrom: anotherClient) size = 1).
	
	self assert: ((aSalesBook purchasesFrom: aClient) includes: sale1).
	self assert: ((aSalesBook purchasesFrom: aClient) includes: sale2).
	self assert: ((aSalesBook purchasesFrom: anotherClient) includes: sale3).
	
	self deny: ((aSalesBook purchasesFrom: anotherClient) includes: sale1).
	self deny: ((aSalesBook purchasesFrom: anotherClient) includes: sale2).
	self deny: ((aSalesBook purchasesFrom: aClient) includes: sale3).
	
	! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 6/1/2013 19:42'!
test17CashierShouldntBeAbleToCheckoutWithCreditCardAndClientNameMismatch
	| aCart aCashier aCreditCard aSalesBook aClient |
	aCart := self anEmptyCart.
	aSalesBook:= self anEmptySalesBook.
	aCashier := self aCashierWithSalesBook: aSalesBook.
	aCreditCard:= self aValidCreditCard.
	aClient:= self anotherTestClient.
	
	aCart add: self aTestBook.
	
	self should: [aCashier checkout: aCart withCreditCard: aCreditCard andClient: aClient]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier creditCardNameMismatchDescription ].
	
	self assert: (aSalesBook size = 0).! !

!TusLibrosTest methodsFor: 'CartTimedWrapper' stamp: 'EtchegoyenLajePulver 6/3/2013 16:54'!
test18CartShouldBeInvalidAfterTimeOutTimePassed
	| aCart |
	aCart := self aTimedOutCart.
	
	self should: [aCart add: self aTestBook]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = CartTimedWrapper timeOutDescription ].! !

!TusLibrosTest methodsFor: 'CartTimedWrapper' stamp: 'EtchegoyenLajePulver 6/3/2013 17:17'!
test19CartShouldNotBeInvalidBeforeTimeOutTimePassed
	| aCart |
	aCart := self aNonTimedOutCart.
	
	self shouldnt: [ aCart add: self aTestBook ] raise: Error! !

!TusLibrosTest methodsFor: 'CartTimedWrapper' stamp: 'EtchegoyenLajePulver 6/3/2013 17:21'!
test20NonTimedOutCartShouldBeAbleToRespondEveryCartMessage
	| aCart |
	aCart := self aNonTimedOutCart.
	
	self shouldnt: [ aCart add: self aTestBook ] raise: Error.
	self shouldnt: [ aCart add: self aTestBook withOccurrences: 1] raise: Error.
	self shouldnt: [ aCart includes: self aTestBook ] raise: Error.
	self shouldnt: [ aCart isEmpty] raise: Error.
	self shouldnt: [ aCart occurrencesOf: self aTestBook ] raise: Error.
	self shouldnt: [ aCart size] raise: Error.! !

!TusLibrosTest methodsFor: 'CartTimedWrapper' stamp: 'EtchegoyenLajePulver 6/3/2013 17:44'!
test21EveryOperationShouldResetCartTimeToLive
	| aCart |
	
	aCart := self a20MinutesRemainingCart.
	self assert: (aCart minutesToLive = 20).
	aCart add: self aTestBook.
	self assert: (aCart minutesToLive = 30).
	
	aCart := self a20MinutesRemainingCart.
	self assert: (aCart minutesToLive = 20).
	aCart add: self aTestBook withOccurrences: 1.
	self assert: (aCart minutesToLive = 30).
	
	aCart := self a20MinutesRemainingCart.
	self assert: (aCart minutesToLive = 20).
	aCart includes: self aTestBook.
	self assert: (aCart minutesToLive = 30).
	
	aCart := self a20MinutesRemainingCart.
	self assert: (aCart minutesToLive = 20).
	aCart isEmpty.
	self assert: (aCart minutesToLive = 30).
	
	aCart := self a20MinutesRemainingCart.
	self assert: (aCart minutesToLive = 20).
	aCart occurrencesOf: self aTestBook.
	self assert: (aCart minutesToLive = 30).! !
